import { Component, OnInit, ViewChild } from '@angular/core';
import { STComponent, STColumn, STChange } from '@delon/abc/st';
import { SFComponent, SFRadioWidgetSchema, SFSchema, SFUISchema } from '@delon/form';
import { NzModalService } from 'ng-zorro-antd/modal';
import { SystemService } from '../../services/system.service';

@Component({
  selector: 'app-network-freight-component',
  templateUrl: './network-freight.component.html',
  styleUrls: ['./network-freight.component.less']
})
export class NetworkFreightComponent implements OnInit {
  @ViewChild('st', { static: true })
  st!: STComponent;
  @ViewChild('sf', { static: false }) sf!: SFComponent;
  @ViewChild('sfFre', { static: false }) sfFre!: SFComponent;
  ui: SFUISchema = {};
  ui2: SFUISchema = {};
  schema: SFSchema = {};
  addSchema: SFSchema = {};
  _$expand = false;
  formData :any;
  isVisible = false;
  edit = false;
  editId = false;

  columns: STColumn[] = [
    { title: '公司名称', index: 'enterpriseName' },
    { title: '纳税人识别号', index: 'taxCode' },
    { title: '发票税率', index: 'invoiceTaxRate' },
    { title: '电子发票账号', index: 'electronicInvoiceAccount' },
    { title: 'ETC账号', index: 'etcAccount' },
    { title: '电子合同账号', index: 'electronicContractAccount' },
    { title: '开户行', index: 'bankName' },
    { title: '虚拟账户', index: 'virtualAccount' },
    { title: '附加费比例', index: 'surchargeRate', format: (item: any) => {return item.surchargeRate + '%'} },
    {
      title: '操作',
      buttons: [
        {
          text: '财务设置',
          click: item => this.roleAction(item, 2)
        },
        {
          text: '合同设置',
          click: item => this.roleAction(item, 2)
        },
      ]
    }
  ];

  selectedRows: any[] = [];

  get reqParams (){ 
    return {
    ...this.sf?.value,
  }};

  constructor(public service: SystemService, private nzModalService: NzModalService) {}

  ngOnInit(): void {
    this.initSF()
    this.initSFFre()
  }

  stChange(e: STChange): void {
    switch (e.type) {
      case 'checkbox':
        this.selectedRows = e.checkbox!;
        break;
      case 'filter':
        this.st.load();
        break;
    }
  }
    /**
  * 伸缩查询条件
  */
     expandToggle(): void {
      this._$expand = !this._$expand;
      this.sf?.setValue('/_$expand', this._$expand);
    }
    /**
   * 查询字段个数
   */
     get queryFieldCount(): number {
      return Object.keys(this.schema?.properties || {}).length;
    }
  initSF(){
  this.schema = {
    properties: {
      _$expand: { type: 'boolean', ui: { hidden: true } },
      enterpriseName: {
        type: 'string',
        title: '公司名称',
        ui: { placeholder: '请输入' }
      },
      taxCode: {
        type: 'string',
        title: '纳税人识别号',
        ui: { placeholder: '请输入' }
      },
    }
    
  };
  this.ui = { '*': { spanLabelFixed: 110, grid: { span: 8, gutter: 4 } } };
  }
  initSFFre() {
  this.addSchema = {
    properties: {
      enterpriseName: {
        type: 'string',
        title: '公司名称',
        ui: { placeholder: '请输入' }
      },
      taxCode: {
        type: 'string',
        title: '纳税人识别号',
        ui: { placeholder: '请输入' }
      },
      customerCode: {
        type: 'string',
        title: '税收分类编码',
        ui: { placeholder: '请输入' }
      },
      invoiceTaxRate: {
        type: 'string',
        title: '发票税率',
        ui: { placeholder: '请输入' }
      },
      surchargeRate: {
        type: 'string',
        title: '附加费比例',
        ui: { placeholder: '请输入' }
      },
  
  },
  required: ['enterpriseName', 'taxCode', 'customerType', 'invoiceTaxRate', 'surchargeRate']
  };
this.ui2 = { '*': { spanLabelFixed: 120, grid: { span: 24 } } };
}
  roleAction(value: any,item?: any) {

      this.service.request(this.service.$api_get_crmCustomer, {id: value.id}).subscribe((res: any) => {
        console.log(res)
        if(res) {
          this.formData = res;
        }
      })
      this.edit = true;
      this.editId = value.id;
      this.isVisible = true;
  }

  deleteAction(item?: any) {
    this.nzModalService.error({
      nzTitle: '确认删除？',
      nzClosable: false,
      nzCancelText: '取消',
      nzOnOk: () => {}
    });
  }

  /**
   * 重置表单
   */
  resetSF() {
    this.sf.reset();
  }
  handleCancel() {
    this.isVisible = false
  }

  handleOK() {
    console.log(this.sfFre.value)
    if(!this.sfFre.valid) {
      this.service.msgSrv.warning('请正确填写完整！')
      return
    }
    const params ={
      ...this.sfFre.value
    }
    if(this.editId) {
      params.id = this.editId
    }
    this.service.request(this.service.$api_save_crmCustomer, params).subscribe((res:any) => {
      if(res) {
    this.service.msgSrv.success('保存成功！')
    this.isVisible = false
    this.st.reload();
      } else {
    this.service.msgSrv.warning(res?.msg)

      }
    })
  }
}
